package addbk.midtermAddressBook;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.beans.XMLEncoder;
import java.io.Serializable;
import java.io.ByteArrayOutputStream;
import java.util.Comparator;

public class AddressRecord
    implements Serializable, Comparator {

  private String firstName;
  private String lastName;
  private String address1;
  private String address2;
  private String phone1;
  private String phone2;
  private String phone3;
  PropertyChangeSupport pcs = new PropertyChangeSupport(this);

  public AddressRecord() {
    firstName = "";
    lastName = "";
    address1 = "";
    address2 = "";
    phone1 = "";
    phone2 = "";
    phone3 = "";
  }

  public AddressRecord(String s[]) {

    for (int i = 0; i < s.length; i++) {
      switch (i) {
        case 1:
          firstName = s[1];
          break;
        case 2:
          lastName = s[2];
          break;
        case 7:
          address1 = s[3] +
              "\n" + s[4] + " "
              + s[5] + " "
              + s[6] + " "
              + s[7];
          break;
        case 8:
          address2 = s[8];
          break;
        case 9:
          phone1 = s[9];
          break;
        case 10:
          phone2 = s[10];
          break;
        case 11:
          phone3 = s[11];
          break;
      }
    }
  }

  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public String getLastName() {
     return lastName;
   }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public void setAddress1(String address1) {
    this.address1 = address1;
  }

  public void setAddress2(String address2) {
    this.address2 = address2;
  }

  public String getAddress1() {
   return address1;
 }

 public String getAddress2() {
   return address2;
 }


  public void setPhone1(String phone1) {
    this.phone1 = phone1;
  }

  public void setPhone2(String phone2) {
    this.phone2 = phone2;
  }

  public void setPhone3(String phone3) {
    this.phone3 = phone3;
  }



  public String getPhone1() {
    return phone1;
  }

  public String getPhone2() {
    return phone2;
  }

  public String getPhone3() {
    return phone3;
  }

  public String getName() {
    return firstName + " " + lastName;
  }

  public void addPropertyChangeListener(PropertyChangeListener listener) {
    pcs.addPropertyChangeListener(listener);
  }

  public void removePropertyChangeListener(PropertyChangeListener listener) {
    pcs.removePropertyChangeListener(listener);

  }

  public int compare(Object o1, Object o2) {
    AddressRecord a1 = (AddressRecord) o1;
    AddressRecord a2 = (AddressRecord) o2;
    String n1 = a1.getLastName();
    String n2 = a2.getLastName();
    return n1.compareTo(n2);
  }

  public boolean equals(Object obj) {
    AddressRecord a = (AddressRecord) obj;
    return lastName.equals(a.getLastName());
  }

  public String toXml() {
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    XMLEncoder e = new XMLEncoder(baos);
    e.writeObject(this);
    e.flush();
    return baos.toString();
  }

  public String toString() {
    char comma = ',';
    StringBuffer sb = new StringBuffer();
    sb.append(firstName);
    sb.append(comma);
    sb.append(lastName);
    sb.append(comma);
    sb.append(address1);
    sb.append(comma);
    sb.append(address2);
    sb.append(comma);
    sb.append(phone1);
    sb.append(comma);
    sb.append(phone2);
    sb.append(comma);
    sb.append(phone3);
    // sb.append(comma);
    return sb.toString();
  }

  public void print() {
    println("Name:" + getLastName());
  }

  public void println(Object o) {
    System.out.println(o);
  }

  public void update() {
    pcs.firePropertyChange("addressRecord", null, this);
  }

  public String[] getRecordAsArray() {
    String defaultRecord[] = {
        firstName,
        lastName,
        address1,
        address2,
        phone1,
        phone2,
        phone3};
    return defaultRecord;
  }

}
