package addbk.midtermAddressBook;

public class Global {
 public static final char NULL = '\0'; // Null character.
 public static final char NEWLINE = '\n'; // Newline character.
 public static final char BACKSLASH = '\\'; // Backslash character.
 public static final char COMMA = ','; // Comma character.

 /** Removes escape characters from a string which is being read from a file.
  * The null and backslash characters are converted to comma and newline
  * characters respectively.  */
 public static String removeEscChars(String str) {
   String newStr = null;
   // Convert null to newline character.
   newStr = str.replace(NULL, NEWLINE);
   // Convert backslash to comma character.
   newStr = newStr.replace(BACKSLASH, COMMA);
   return newStr;
 }

 /** Adds escape characters to a string to be written to a file.
 * The newline and comma characters are eliminated.  */
public static String addEscChars(String str) {
  String newStr = null;
  newStr = str.replace(NEWLINE, NULL); // Convert newline to null character.
  newStr = newStr.replace(COMMA, BACKSLASH); // Convert comma to backslash.
  return newStr;
}





 }
