package net.rmi.rjs;

import futils.Futil;
import gui.In;

import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.io.File;
import java.io.FileInputStream;

public class RmiFileServerTest {
    private String rmiUrl = null;
    private net.rmi.rjs.RMIFileServerInterface RMIFileServerInterface = null;
    // this is my hack to force SDA in initium to upload
    // JAWS jar with stubs.
    //public static net.rmi.armi.RemoteHelloImplementation_Skel a=
    //        new RemoteHelloImplementation_Skel();
   //public static net.rmi.armi.RemoteHelloImplementation_Stub b=
   //         new RemoteHelloImplementation_Stub();

    public RmiFileServerTest(String location) {
        //webStartClassLoaderHack();
        rmiUrl = location;
        try {
            RMIFileServerInterface = lookupRmiFileServerInterface();
        } catch (NotBoundException e) {
            e.printStackTrace();
        } catch (java.net.MalformedURLException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }
    public RMIFileServerInterface getRmiFileServerInterface() {
        return RMIFileServerInterface;
    }

    private RMIFileServerInterface lookupRmiFileServerInterface()
            throws NotBoundException,
            java.net.MalformedURLException,
            RemoteException {
        RMIFileServerInterface rh = (RMIFileServerInterface)
                Naming.lookup(rmiUrl);
        return rh;
    }

    public static void main(String args[]) {
        try {
            final String serverHostName = In.getString("enter sever ipAddress");
            //System.setProperty("java.rmi.server.hostname", serverHostName);




            RmiFileServerTest rhc =
                    new RmiFileServerTest(
                            "rmi://" +
                    serverHostName +
                    "/RemoteHello");
            RMIFileServerInterface rhi = rhc.getRmiFileServerInterface();
            String ans = rhi.getMsg();
            rhi.testGetMsg();
            System.out.println(ans);
            File readFile = Futil.getReadFile("select a readfile to upload");

            byte b[] = Futil.readBytes(readFile);
            rhi.putFile(new File("test.txt"),b);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public String getMsg() throws RemoteException {
        return RMIFileServerInterface.getMsg();
    }

    public void testGetMsg()
            throws
            RemoteException {
        System.out.println(RMIFileServerInterface.getMsg());
    }
}
